#include <errno.h>
#include <stdio.h>
#include <locale.h>
#include <wchar.h>

#define DEFINITION_MAX_LINES          2
#define DEFINITION_MAX_CHARACTERS  1024
#define LINE_BUFFER_SIZE           1024

static wchar_t zenkaku[DEFINITION_MAX_LINES][DEFINITION_MAX_CHARACTERS];
static wchar_t hankaku[DEFINITION_MAX_LINES][DEFINITION_MAX_CHARACTERS];

/* read a line from a stream as a wchar_t string */
wint_t wreadline(FILE *stream, wchar_t *buf, int size){
int i;
wint_t wbuf;
   for(i=0 ; i<size-1 ; i++){
      wbuf = getwc(stream);
/*
      printf("0x%x\n",wbuf);
*/
      if( wbuf == WEOF ){
         buf[i] = L'\0';
         return WEOF;
      }else if( wbuf == L'\n' ){
         buf[i] = L'\0';
         return L' ';
      }else
         buf[i] = (wchar_t)wbuf;
   }
   buf[i] = L'\0';
   return L' ';
}

void main(int argc, char **argv){
int i,j,k,l,pos;
wchar_t in_line[LINE_BUFFER_SIZE];
wchar_t out_line[LINE_BUFFER_SIZE];
FILE *fin;
wchar_t *wp = NULL;
wint_t wbuf = 1;

   setlocale(LC_ALL, "");

   if((fin = fopen("zenkaku.def","r")) != NULL){ /* reading Zenkaku definition file */
      for(i=0 ; i<DEFINITION_MAX_LINES ; i++){
         wreadline(fin, zenkaku[i], DEFINITION_MAX_CHARACTERS);
/*         printf("%s\n",zenkaku[i]);
         printf("%d\n",wcslen(zenkaku[i]));
*/
      }
      fclose(fin);
   }else{
      for(i=0 ; i<DEFINITION_MAX_LINES ; i++)
         wcscpy(zenkaku[i], L"");
   }

   if((fin = fopen("hankaku.def","r")) != NULL){ /* reading Hankaku definition file */
      for(i=0 ; i<DEFINITION_MAX_LINES ; i++){
         wreadline(fin, hankaku[i], DEFINITION_MAX_CHARACTERS);
/*         printf("%s\n",hankaku[i]);
         printf("%d\n",wcslen(hankaku[i]));
*/
      }
      fclose(fin);
   }else{
      for(i=0 ; i<DEFINITION_MAX_LINES ; i++)
         wcscpy(hankaku[i], L"");
   }

   while(wbuf != WEOF){

      wbuf = wreadline(stdin, in_line, LINE_BUFFER_SIZE);

      for(i=0, j=0 ; i<wcslen(in_line) ; i++){ /* converting */
         for(k=0 ; k<DEFINITION_MAX_LINES ; k++){
            if((wp = wcsrchr(zenkaku[k], in_line[i])) != NULL){ 
               pos = wp - zenkaku[k];
               for(l=0 ; l<k+1 ; l++){
                  out_line[j] = hankaku[k][pos*(k+1)+l];
                  j++;
               }
               k=DEFINITION_MAX_LINES;
            }else if(k == DEFINITION_MAX_LINES-1){
               out_line[j] = in_line[i];
               j++;
               k=DEFINITION_MAX_LINES;
            }
         }
      }
      out_line[j]=L'\0';

      printf("%ls\n",out_line);
   }
      printf("\n");
}
